gocek/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('helloworld.urls')),
    path('hiburan/', include('hiburan.urls')),
    path('pasar/', include('pasar_zaldy.urls')),
    path('rumah-sakit/', include('rumah_sakit.urls')),
    path('restoran/', include('restoran.urls')),
    path('account/', include('sistemlogin.urls')),
]

rumah_sakit/urls.py
from django.urls import path
from . import views
from .views import *

app_name = 'rumah_sakit'

urlpatterns = [
    path('', views.index, name='index'),
    path('tambah-rs/', views.tambahRS, name='tambahRS'),
    path('update-rumah-sakit/<int:pk>/', views.updateRS, name='updateRS'),
    path('detail-rumah-sakit/<int:pk>/', views.detailRS, name='detailRS'),
    path('detail-rumah-sakit/<int:pk>/tambah-dokter/', views.tambahDokter, name='tambahDokter'),
]

rumah_sakit/models.py
from django.db import models
from django.core.validators import RegexValidator


# Create your models here.
class RumahSakit(models.Model):
    nama_rs = models.CharField(max_length = 100)
    link_foto = models.TextField()
    statusOpen = (
        ('Buka', 'Buka'),
        ('Tutup', 'Tutup'),
    )

    status = models.TextField(choices = statusOpen)
    link_rs = models.TextField()
    statusPasien = (
        ('Iya', 'Menerima '),
        ('Tidak', 'Tidak Menerima'),
    )   
    covid = models.TextField(choices = statusPasien)
    statusTest = (
        ('Iya', 'Menerima'),
        ('Tidak', 'Tidak Menerima'),
    )
    test_rs = models.TextField(choices = statusTest)
    alamat = models.TextField(blank=True, null=True)

    def __str__(self):
        return self.nama_rs

class Dokter(models.Model):
    
    rs = models.ForeignKey(RumahSakit, on_delete = models.CASCADE)
    nama_dokter = models.CharField(max_length = 25)
    spesialis = models.CharField(max_length = 25)
    layanan_start = models.TimeField()
    layanan_end = models.TimeField()
    phone_number = models.IntegerField()

    def __str__(self):
        return self.nama_dokter

rumah_sakit/forms.py
from django import forms
from .models import *

class RumahSakitForm(forms.ModelForm):
    nama_rs = forms.CharField(label = 'Nama Rumah Sakit', max_length=50, required = True, 
        widget = forms.TextInput(attrs={
            'placeholder' : 'Rumah Sakit Sentosa',
            'class' : 'form-control',
            'required': True,
        })
    )

    link_foto = forms.URLField(label = 'Foto', required = True,
        widget = forms.TextInput(attrs={
            'placeholder' : 'masukkan link foto rumah sakit',
            'class' : 'form-control',
            'required': True,
        })
    )

    link_rs = forms.URLField(label = 'Link Rumah Sakit', required = True,
        widget = forms.TextInput(attrs={
            'placeholder' : 'masukkan link website rumah sakit',
            'class' : 'form-control',
            'type' : 'text',
        })
    )

    alamat = forms.CharField(label = 'Alamat Rumah Sakit',
        widget = forms.TextInput(attrs={
            'placeholder' : 'Jl. Pramuka, Jakarta Timur',
            'class' : 'form-control',
            'type' : 'text',
            'required': True,
        })
    )

    class Meta:
        model = RumahSakit
        fields = [
            'nama_rs',
            'status',
            'link_foto',
            'link_rs',
            'covid',
            'test_rs',
            'alamat',
        ]

class DokterForm(forms.ModelForm):  
    nama_dokter = forms.CharField(label = 'Nama Dokter', max_length=50, required = True, 
        widget = forms.TextInput(attrs={
            'placeholder' : 'Dr Adi Wijaya',
            'class' : 'form-control',
            'type' : 'text',
            'required': True,
        })
    )
    spesialis = forms.CharField(label = 'Spesialis', max_length=50, required = True, 
        widget = forms.TextInput(attrs={
            'class' : 'form-control',
            'placeholder' : 'Sp.OG/SP.A/SP.KK/Psikiater/dll',
            'required' : True,
        })
    )
    layanan_start = forms.TimeField(label = 'Jam Mulai Layanan', widget = forms.TextInput(attrs={
            'class' : 'form-control',
            'placeholder' : '08:00',
            'required' : True,
        }))
    layanan_end = forms.TimeField(label = 'Jam Berakhir Layanan',widget = forms.TextInput(attrs={
            'class' : 'form-control',
            'placeholder' : '12:00',
            'required' : True,
        }))
    phone_number = forms.CharField(label = 'No. Whatsapp ',
        widget = forms.TextInput(attrs={
            'class' : 'form-control',
            'placeholder' : '62812xxxxxxxx'
        })
    )

    class Meta:
        model = Dokter
        fields = [
            'nama_dokter',
            'spesialis',
            'layanan_start',
            'layanan_end',
            'phone_number'
        ]

rumah_sakit/views.py
from django.shortcuts import render, redirect
from . import forms, models
from .models import RumahSakit, Dokter
from .forms import RumahSakitForm, DokterForm

# Create your views here.

def index(request):
    data_rs = RumahSakit.objects.all()
    response = {'data_rs' : data_rs}
    return render(request, 'index.html', response)

def tambahRS(request):
    if request.method == "POST" or None:
        formRS = forms.RumahSakitForm(request.POST)
        if formRS.is_valid():
            dataRS = models.RumahSakit()
            dataRS.nama_rs = formRS.cleaned_data['nama_rs']
            dataRS.status = formRS.cleaned_data['status']
            dataRS.link_foto = formRS.cleaned_data['link_foto']
            dataRS.link_rs = formRS.cleaned_data['link_rs']
            dataRS.covid = formRS.cleaned_data['covid']
            dataRS.test_rs = formRS.cleaned_data['test_rs']
            dataRS.alamat = formRS.cleaned_data['alamat']
            dataRS.save()
            return index(request)

    response = {'form_rs' : forms.RumahSakitForm}
    return render(request, 'tambahRS.html', response)
        
def tambahDokter(request, pk):
    if request.method == "POST" or None:
        formDokter = forms.DokterForm(request.POST)
        if formDokter.is_valid():
            dataDokter = models.Dokter()
            dataDokter.rs = models.RumahSakit.objects.get(pk=pk)
            dataDokter.nama_dokter = formDokter.cleaned_data['nama_dokter']
            dataDokter.spesialis = formDokter.cleaned_data['spesialis']
            dataDokter.layanan_start = formDokter.cleaned_data['layanan_start']
            dataDokter.layanan_end = formDokter.cleaned_data['layanan_end']
            dataDokter.phone_number = formDokter.cleaned_data['phone_number']
            dataDokter.save()
            return redirect('/rumah-sakit/detail-rumah-sakit/'+str(pk))
    else: 
        args = {'form_dokter' : forms.DokterForm}
        return render(request, 'tambahDokter.html', args)

def detailRS(request, pk):
    rs = RumahSakit.objects.get(pk=pk)
    dokter = Dokter.objects.filter(rs=rs)
    response = {'rs':rs, 'dokter':dokter}
    return render(request, 'detailRS.html', response)
    
def updateRS(request, pk):
    rs = RumahSakit.objects.get(pk=pk)
    formRS = RumahSakitForm()
    if request.method == "POST" or None:
        formRS = forms.RumahSakitForm(request.POST)
        if not formRS.is_valid():
            rs.status = formRS.cleaned_data['status']
            rs.covid = formRS.cleaned_data['covid']
            rs.test_rs = formRS.cleaned_data['test_rs']
            rs.alamat = formRS.cleaned_data['alamat']
            rs.save()
            return redirect('/rumah-sakit/detail-rumah-sakit/'+str(pk))
    response = {'form_rs' : formRS, 'rs': rs}
    return render(request, 'updateRS.html', response)

rumah_sakit/templates/detailRS.html
{% extends 'base.html' %}
{% block meta %}
    {% load static %}
    <title>{{rs.nama_rs}}</title>
{% endblock %}
{% block headercontent %}
    <span>{{rs.nama_rs}}</span>
{% endblock %}
{% block content %}
    <div class="container-fluid" style="margin: auto;">
    
        <div> <a class="btn btn-primary btn-block ml-auto" style="font-size: large; color: white; border-radius: 20px;
            width: 12rem; margin-bottom: 30px ;margin-top: 30px;" href="{% url 'rumah_sakit:updateRS' rs.pk %}"
                    role="button">Update Informasi</a>
        </div>            
        <div class="row justify-content-center">
            <div class="row">
                <div class="col my-auto">
                    <img src="{{rs.link_foto}}" alt="" style="width: 35rem;">
                </div>
                <div class="col">
                    <br><br><br><br>
                    <div class="card bg-light mb-2" style="width: 25rem; color: E0E0E0; ">
                        <div class="container">
                            <h6>Nama Rumah Sakit:</h6>
                            <p>{{rs.nama_rs}}</p>
                        </div>
                    </div>
                    <div class="card bg-light mb-2" style="width: 25rem; background-color: E0E0E0;">
                        <div class="container">
                            <h6>Status:</h6>
                            <p>{{rs.status}}</p>
                        </div>
                    </div>                    
                    <div class="card bg-light mb-2" style="width: 25rem; background-color: E0E0E0; ">
                        <div class="container">
                            <h6>Web Rumah Sakit:</h6>
                            <p><a href="{{rs.link_rs}}">{{rs.link_rs}}</a></p>
                        </div>
                    </div>

                    <div class="card bg-light mb-2"  style="width: 25rem; background-color: E0E0E0; ">
                        <div class="container">
                            <h6>Menerima Pasien Covid:</h6>
                            <p>{{rs.covid}}</p>   
                        </div>
                    </div>                 
                    <div class="card bg-light mb-2"  style="width: 25rem; background-color: E0E0E0; ">
                        <div class="container">                        
                            <h6>Menerima Pemeriksaan Covid:</h6>
                            <p>{{rs.test_rs}}</p>
                        </div>
                    </div>
                    <div class="card bg-light mb-2" style="width: 25rem; background-color: E0E0E0; ">
                        <div class="container">
                            <h6>Alamat:</h6>
                            <p>{{rs.alamat}}</p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
            <br><br><br><br>

        <div class="container-fluid">
            <h3 class="text-center" style="color:#4180E2;">List Dokter</h3>
            <br>
            <div class="text-right"><a id="detail" href="{% url 'rumah_sakit:tambahDokter' rs.pk %}" href="#" class="btn btn-light" style= "border-radius: 20px; width: 10rem; font-weight: bold;">Tambah Dokter</a></div>
            <table class="table text-center">
                <br>
                <thead class="thead-light">
                    <tr>
                        <th scope="col">Nama Dokter</th>
                        <th scope="col">Spesialis</th>
                        <th scope="col">Jam Kerja</th>
                        <th scope="col">Kontak</th>
                    </tr>
                </thead>
                <tbody>
                    {% for dokter in dokter %}
                    <tr>
                        <td>{{dokter.nama_dokter}}</td>
                        <td>{{dokter.spesialis}}</td>
                        <td>{{dokter.layanan_start}} - {{dokter.layanan_end}}</td>
                        <td><a href="https://wa.me/{{dokter.phone_number}}" target="_blank" class="btn btn-success" style="border-radius: 20px;">Whatsapp</a></td>
                    </tr>
                    {% endfor %}
                </tbody>
            </table>
        </div>
    </div>
    
{% endblock %}

rumah_sakit/templates/index.html
{% extends 'base.html' %}
{% block meta %}
<!-- blm load css -->
    {% load static %}
    <!-- <link src="{% static 'rumah_sakit/style.css' %}"> -->
    <title>Rumah Sakit</title>
{% endblock %}
{% block headercontent %}
    <span>Rumah Sakit</span>
    <br>
{% endblock %}
{% block content %}
<div class="container">
    <div> 
        <a class="btn btn-primary btn-block ml-auto" style="font-size: large; color: white;  width: 12rem; margin-bottom: 30px; margin-top: 30px; border-radius: 20px;" href="{% url 'rumah_sakit:tambahRS' %}" role="button">+ Tambah RS</a>
    </div>

    <div class="row justify-content-center">
        {% for rs in data_rs %}
        <div class="card"  style="background-color: #6E96D3; width: 20rem; box-shadow: 1px 5px 5px 0 rgba(0,0,0,0.2); margin-right: 50px; margin-bottom: 50px; max-width: 100%; align-content: center; border-radius: 10px ;">
            <img class="card-img-top" src="{{rs.link_foto}}" alt="Card image cap">
            <div class="card-body">
                <h5 class="card-title text-center"><strong>{{rs.nama_rs}}</strong> </h5>
                <div class="card-body">
                    <h6><strong> Status:</strong></h6>
                    <span>{{rs.status}}</span>
                    <h6><strong>Menerima Rapid/Swab:</strong></h6>
                    <span>{{rs.test_rs}}</span>
                    <h6><strong>Alamat:</strong></h6>
                    <span>{{rs.alamat}}</span>
                </div>
                <div class="text-center"><a id="detail" href="{% url 'rumah_sakit:detailRS' rs.pk %}" href="#" class="btn btn-light" style= "border-radius: 20px; width: 8rem; font-weight: bold;">Lihat Detail</a></div>
            </div>
        </div>
        {% endfor %}
        
    </div>
</div>


{% endblock %}

rumah_sakit/templates/tambahDokter.html
{% extends 'base.html' %}
{% block meta %}
    {% load static %}
    <title>Rumah Sakit</title>
{% endblock %}
{% block headercontent %}
    <span>Tambah Dokter</span>
    <!-- button search disini -->
{% endblock %}
{% block content %}
<br><br>
    <div class="container" style="background-color: #f7f7f7">
        <br><br>
            <form action="" method="POST">
                {% csrf_token %}
                <table>
                    {% for form in form_dokter %}
                    <tr style="line-height: 4rem;">
                        <td style="width: 30rem; font-size: large; font-weight: bold;">{{form.label}} </td>
                        <td style="width: 35rem;">{{form}}</td>
                    </tr>
                    {% endfor %}
                </table>
                <div class="text-right"> 
                    <input class="btn btn-primary btn-lg" type="submit" value="Tambahkan" style="line-height: 1rem; font-size: 1rem;">
                </div>
            </form>
            <br><br>
            <br><br>
    </div>
{% endblock %}

rumah_sakit/templates/tambahRS.html
{% extends 'base.html' %}
{% block meta %}
    {% load static %}
    <title>Rumah Sakit</title>
{% endblock %}
{% block headercontent %}
    <span>Tambah Rumah Sakit</span>
{% endblock %}
{% block content %}
<br><br>
    <div class="container" style="background-color: #f7f7f7">
        <br><br>
            <form action="" method="POST">
                {% csrf_token %}
                <table>
                    {% for form in form_rs %}
                    <tr style="line-height: 4rem;">
                        <td style="width: 30rem; font-size: large; font-weight: bold;">{{form.label}} </td>
                        <td style="width: 35rem;">{{form}}</td>
                    </tr>
                    {% endfor %}
                </table>
                <div class="text-right"> 
                    <input class="btn btn-primary btn-lg" type="submit" value="Tambahkan" style="line-height: 1rem; font-size: 1rem;">
                </div>
            </form>
            <br><br>
            <br><br>
    </div>
{% endblock %}

rumah_sakit/templates/updateRS.html
{% extends 'base.html' %}
{% block meta %}
    {% load static %}
    <title>Rumah Sakit</title>
{% endblock %}
{% block headercontent %}
    <span>Update {{rs.nama_rs}}</span>
{% endblock %}
{% block content %}
<br><br>
    <div class="container" style="background-color: #f7f7f7">
        <br><br>
            <form action="" method="POST">
                {% csrf_token %}
                <table>
                    {% for form in form_rs %}
                        {% if form.label == "Nama Rumah Sakit" %}
                        <tr style="line-height: 4rem;">
                            <td style="width: 30rem; font-size: large; font-weight: bold;">{{form.label}}</td>
                            <td style="width: 35rem;">{{rs.nama_rs}}</td>
                        </tr>
                        {% elif form.label == "Foto" %}     
                        {% elif form.label == "Alamat" %}     
                        {% elif form.label == "Link Rumah Sakit" %}
                        <tr style="line-height: 4rem;">
                            <td style="width: 30rem; font-size: large; font-weight: bold;">{{form.label}}</td>
                            <td style="width: 35rem;">{{rs.link_rs}}</td>
                        </tr>
                        {% else %}
                        <tr style="line-height: 4rem;">
                            <td style="width: 30rem; font-size: large; font-weight: bold;">{{form.label}}</td>
                            <td style="width: 35rem;">{{form}}</td>
                        </tr>
                        {% endif %}
                    {% endfor %}
                </table>
                <div class="text-right"> 
                    <input class="btn btn-primary btn-lg" type="submit" value="Simpan" style="line-height: 1rem; font-size: 1rem;">
                </div>
            </form>
            <br><br>
    </div>
{% endblock %}